#ifndef _ZMEMORY_H_
#  define _ZMEMORY_H_

   /***********************************************************
    * To enable debugging
    *
    *    #  if 1
    *
    * to disable debugging
    *
    *    #  if 0
    *
    ***********************************************************/

#  if 1
#     define ZMEMORY_ENABLE
#  endif

#  ifdef ZMEMORY_ENABLE

#     include <stdio.h>

      void zmemorySetFileName(const char *fileName);

      void *zmemoryMalloc(
         int         theSize,
         const char *file,
         int         line
      );

      void *zmemoryCalloc(
         size_t      num,
         size_t      size,
         const char *file,
         int         line
      );

      void *zmemoryRealloc(
         void       *thePointer,
         size_t      theSize,
         const char *file,
         int         line
      );

      void zmemoryFree(
         void       *thePointer,
         const char *file,
         int         line
      );

#     define ZFILENAME(name) \
         zmemorySetFileName(name)

#     define ZMALLOC(theSize)  \
         zmemoryMalloc(theSize, __FILE__, __LINE__)

#     define ZCALLOC(theNumber, theSize)  \
         zmemoryCalloc(theNumber, theSize, __FILE__, __LINE__)

#     define ZREALLOC(thePointer, theSize)  \
         zmemoryRealloc(thePointer, theSize, __FILE__, __LINE__)

#     define ZFREE(thePointer) \
         zmemoryFree(thePointer, __FILE__, __LINE__)

#  else

#     include <stdlib.h>

#     define ZFILENAME(name)
#     define ZMALLOC(theSize)              malloc(theSize)
#     define ZCALLOC(theNumber,   theSize) calloc(theNumber,  theSize)
#     define ZREALLOC(thePointer, theSize) realloc(thePointer, theSize)
#     define ZFREE(thePointer)             free(thePointer)

#  endif

#endif
